#!/usr/bin/perl
#################################################
# chuserdata.pl
# Dieses Script ndert Benutzerdaten je nach POST Ergebnis
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# ------------

require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require '../../miscfunc.pl';
require '../../output.pl';
require '../../pwdup.pl';

# Benutzer- und Formdaten auswerten ...
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
$POSTDATA = <STDIN>;
chomp $POSTDATA;
%CHFORMDATA = hashFormData($POSTDATA);

# HTML-Kopf ausgeben
print $http_header;
print html_header("Benutzerdaten &auml;ndern");

# Benutzerrechte ueberpruefen ...
if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Benutzerdaten &auml;ndern","Aktion wird nicht ausgef&uuml;hrt, Sie haben keine ben&ouml;tigten Rechte.",1,"","",1);
  exit;
}

# Wurden Daten uebergeben ???
if ($CHFORMDATA{'username'} eq "") {
  print html_webtoolserror("Benutzerdaten &auml;ndern","Aktion wird nicht ausgef&uuml;hrt, Sie haben keine Parameter &uuml;bergeben.",1,"shuserlist.cgi","Benutzerliste",1);
  exit;
}

# Benutzerdaten des zu bearbeiten Benutzers ermitteln ...
$OUSERNAME = $CHFORMDATA{'username'};
@OUSERDATA = getuserdata($OUSERNAME);

print html_webtoolsheader("#ffffff","Benutzerdaten ge&auml;ndert<br><A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
print "<H1>Benutzerdaten &auml;ndern</H1><U>Ergebnis:</U> ($CHFORMDATA{'username'})";
print "<TABLE BORDER=1 BGCOLOR=#ffff00>";
print "<TR><TH>Aktion</TH><TH>&Auml;nderung?</TH><TH>Ergebnis</TH><TH>Anmerkung</TH></TR>";

# Allgemeiner Name
print "<TR><TD><I>voller Name</I></TD>";
$FULLNAME = $CHFORMDATA{'lname'};
$C_FULLNAME = "";
if ($FULLNAME ne $OUSERDATA[2]) {
  # Unsichere Zeichen entfernen
  $FULLNAME = convert_special_chars($FULLNAME);
  $FULLNAME =~ s/[^a-zA-Z0-9\-\ \_\+]//g;
  print "<TD>Ja</TD>";
  $C_FULLNAME = sprintf "-f \"%s\"", $FULLNAME;
  $CHFNres = `/usr/bin/chfn $C_FULLNAME -q $OUSERNAME && echo ok`;
  chomp $CHFNres;
  if ($CHFNres ne "ok") {
    print "<TD>&Auml;nderung fehlgeschlagen</TD><TD>Problem unbekannt</TD></TR>";
  } else {
    print "<TD>Erfolgreich</TD><TD>Der Name wurde auf <FONT COLOR=#0000ff>$FULLNAME</FONT> ge&auml;ndert</TD></TR>";
  }
} else {
  print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
}

# Klasse ...
print "<TR><TD><I>Abteilung</I></TD>";
$KLASSE = $CHFORMDATA{'klasse'};
$C_KLASSE = "";
if ($KLASSE ne $OUSERDATA[8]) {
  # Unsichere Zeichen entfernen
  $KLASSE = convert_special_chars($KLASSE);
  $KLASSE =~ s/[^a-zA-Z0-9\-\ \_\+]//g;
  print "<TD>Ja</TD>";
  $C_KLASSE = sprintf "-o \"%s;%s;%s;%s\"", $KLASSE, $OUSERDATA[9], $OUSERDATA[10], $OUSERDATA[11];
  $CHFNres = `/usr/bin/chfn $C_KLASSE -q $OUSERNAME && echo ok`;
  chomp $CHFNres;
  if ($CHFNres ne "ok") {
    print "<TD>&Auml;nder fehlgeschlagen</TD><TD>Problem unbekannt</TD></TR>";
  } else {
    print "<TD>Erfolgreich</TD><TD>Die Abteilung wurde auf <FONT COLOR=#0000ff>$KLASSE</FONT> ge&auml;ndert."; 
    if ($OUSERDATA[9] eq "") {
      print "</TD>";
    } else {
      print "</TD></TR>";
    }
  }
} else {
  print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
}

#Passwort
print "<TR><TD><I>Passwort</I></TD>";
$PASSWD = $CHFORMDATA{'passwd'};
if (length($PASSWD)>8) {
  print "<TD>Ja</TD><TD>Passwort wird nicht ge&auml;ndert</TD><TD>Verwenden Sie maximal 8 Zeichen f&uuml;r das Passwort</TD></TR>";
} else {
  $C_PASSWD = "";
  if ($PASSWD ne "") {
    open (PASSCH,"|/usr/sbin/chpasswd");
    print PASSCH "$OUSERNAME:$PASSWD\n";
    close(PASSCH);
    $erg=system("/usr/bin/smbpasswd -a -s $OUSERNAME $PASSWD >> /dev/null");
    createpassdata();
    printf "<TD>Ja</TD><TD>Passwort ge&auml;ndert</TD><TD>Das neue Passwort besitzt %d Zeichen</TD></TR>",length($PASSWD);
  } else {
    print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
  }
}

# Shell ...
print "<TR><TD><I>Shell</I></TD>";
$SHELL = $CHFORMDATA{'shell'};
$TMPSHELL = $SHELL;
$C_SHELL = "";
if ($SHELL ne $OUSERDATA[6]) {
  # Unsichere Zeichen entfernen
  $SHELL = convert_special_chars($SHELL);
  $SHELL =~ s/[^a-zA-Z0-9\-\_\+\/]//g;
  print "<TD>Ja</TD>";
  if ($SHELL ne $TMPSHELL) {
    print "<TD>Die Shell wurde nicht g&auml;ndert</TD><TD>Die Shell besitzt unsichere Zeichen</TD></TR>"; 
  } else {
    $C_SHELL = sprintf "-s \"%s\"", $SHELL;
    $CHFNres = `/usr/sbin/usermod $C_SHELL $OUSERNAME && echo ok`;
    chomp $CHFNres;
    if ($CHFNres ne "ok") {
      print "<TD>&Auml;nder fehlgeschlagen</TD><TD>Problem unbekannt</TD></TR>";
    } else {
      print "<TD>Erfolgreich</TD><TD>Die Shell wurde auf <FONT COLOR=#0000ff>$SHELL</FONT> ge&auml;ndert.</TD></TR>"; 
    }
  }
} else {
  print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
}

# primaere Gruppe ...
print "<TR><TD><I>pim&auml;re Gruppe</I></TD>";
$PGROUP = $CHFORMDATA{'sagroup'};
#$PGROUP = $CHFORMDATA{'pgroup'};
$TMPPGROUP = $PGROUP;
$C_PGROUP = "";
@groupdata=getgrnam($PGROUP);
if ($groupdata[2] != $OUSERDATA[4]) {
  # Unsichere Zeichen entfernen
  $PGROUP = convert_special_chars($PGROUP);
  $PGROUP =~ s/[^a-zA-Z0-9\-\_\+\/]//g;
  print "<TD>Ja</TD>";
  if ($PGROUP ne $TMPPGROUP) {
    print "<TD>Die prim&auml;re Gruppe wurde nicht g&auml;ndert</TD><TD>Sie besitzt unsichere Zeichen</TD></TR>"; 
  } else {
    $C_PGROUP = sprintf "-g \"%s\"", $PGROUP;
    $CHFNres = `/usr/sbin/usermod $C_PGROUP $OUSERNAME && echo ok`;
    chomp $CHFNres;
    if ($CHFNres ne "ok") {
      print "<TD>&Auml;nder fehlgeschlagen</TD><TD>Problem unbekannt</TD></TR>";
    } else {
      print "<TD>Erfolgreich</TD><TD>Die prim&auml;re Gruppe wurde auf <FONT COLOR=#0000ff>$PGROUP</FONT> ge&auml;ndert.</TD></TR>"; 
    }
  }
} else {
  print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
}

# andere Gruppe ...
print "<TR><TD><I>Sekund&auml;re Gruppen</I></TD>";
$OGROUPS = $CHFORMDATA{'ogroups'};
$TMPOGROUPS = $OGROUPS;
$C_GROUPS = "";
$GROUPCHANGED = 0;
$EXTRAINFO = 0;
@aktgruppen = getgroups($OUSERNAME);
$PGRP = shift @aktgruppen; # primaere Gruppe aus Liste entfernen
if (extgrpcheck($OUSERNAME)) { # wenn pr. Gruppe auch sek. Gruppe
  unshift(@aktgruppen,$PGRP);
}
@selgruppen = (split(/\,/, $SAGROUP),split(/\,/, $OGROUPS));
foreach (@selgruppen) {
  $aa = $_;
  if ($aa ne (grep(/^$aa$/,@aktgruppen))[0]) {
    $GROUPCHANGED = 1;
  }
  if ($aa eq $PGRP) {
    $EXTRAINFO = 1;
  }
}
foreach (@aktgruppen) {
  $aa = $_;
  if ($aa ne (grep(/^$aa$/,@selgruppen))[0]) {
    $GROUPCHANGED = 1;
  }
}
if ($GROUPCHANGED == 1) {
  # Unsichere Zeichen entfernen
  $OGROUPS = convert_special_chars($OGROUPS);
  $OGROUPS =~ s/[^a-zA-Z0-9\-\_\+\/\,]//g;
  print "<TD>Ja</TD>";
#  print "$SAGROUP $TMPSAGROUP $OGROUPS $TMPOGROUPS";
  if ($OGROUPS ne $TMPOGROUPS) {
    print "<TD>Die WebTools- und sekund&auml;ren Gruppen wurde nicht g&auml;ndert</TD><TD>Sie besitzten unsichere Zeichen</TD></TR>"; 
  } else {
    if ($OGROUPS ne "") {
        $C_GROUPS = "$OGROUPS";
    }
    $TMPGROUPS = $C_GROUPS;
    $C_GROUPS = "-G \"$C_GROUPS\"";
    $CHFNres = `/usr/sbin/usermod $C_GROUPS $OUSERNAME && echo ok`;
    chomp $CHFNres;
    if ($CHFNres ne "ok") {
      print "<TD>&Auml;ndern fehlgeschlagen</TD><TD>Problem unbekannt.</TD></TR>";
    } else {
      print "<TD>Erfolgreich</TD><TD>Folgende Gruppe(n) wurden gesetzt: <FONT COLOR=#0000ff>$TMPGROUPS</FONT>";
      if ($EXTRAINFO == 1) {
        print "<BR>Die prim&auml;re Gruppe ist auch sekund&auml;re Gruppe, dies ist nicht sinnvoll!</TD></TR>";
      } else {
        print "</TD></TR>";
      } 
    }
  }
} else {
  print "<TD>Nein</TD><TD>-</TD><TD>-</TD></TR>";
}


print "</TABLE><P>";
print html_webtoolsbuttons("../index.cgi","Hauptmen&uuml;","shuserdata.cgi?username=$OUSERNAME","Benutzerdaten von $OUSERNAME","shuserlist.cgi","Benutzerliste");
print html_extfooter(getfullver());
