#!/usr/bin/perl
#################################################
# index.pl
# Dieses Script stellt die "richtige" admin-startseite zur Verfgung.
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

require '../output.pl';
require '../config.pl';
require '../userdata.pl';

# Durchsucht direkte Unterverzeichnisse nach modinfo.dat
# Parameter1 : SA-Recht
# Rueckgabe  : Liste aller Verzeichnisse mit Paketen
sub getmodules {
  my $saright = $_[0];
  local(@res,@modinfo,@dentries);
  
  opendir SADIR, "$WWWHOMEPFAD$WWWSAPFAD/admin" or print "mooo";
  @dentries = readdir(SADIR);
  closedir SADIR;
  foreach(@dentries) {
    if (-r "./$_/modinfo.dat") {
      open (MODINFODAT, "$_/modinfo.dat");
      @modinfo = <MODINFODAT>;
      close (MODINFODAT);
      if (($saright == 1)&&($modinfo[3] == 1)) { @res = (@res,$_);}
      if (($saright == 2)&&($modinfo[4] == 1)) { @res = (@res,$_);}
      if (($saright == 3)&&($modinfo[5] == 1)) { @res = (@res,$_);}
    }
  }
  return @res;
}

@userinfo = getuserdata($ENV{'REMOTE_USER'});

print $http_header;

print html_header("WebTools - Hauptmen&uuml;");
if (@userinfo == 0) {
  print html_webtoolserror("Hauptmen&uuml;","Es ist ein erweiterter Fehler Nr. 1 aufgetreten. <BR>Das hei&szlig;t: Es existiert ein Eintrag in der Server-Passwortdatei, aber keiner in der Globalen Passwortdatei.");
  exit(0);
}
if ($userinfo[7]==0) {
  print html_webtoolserror("Hauptmen&uuml;","Sie haben kein Recht die WebTools zu verwenden.");
  exit;
}
print html_webtoolsheader("#ffffff","Hauptmen&uuml;",$webtools_version);
print "<TABLE><TR><TD>";
print "<H3>Herzlich willkommen $userinfo[2]</H3>\n";
print "</TD></TR><TR><TD ALIGN=center>";
@mods = getmodules($userinfo[7]);
@mods = sort @mods;
foreach (@mods) {
  open(MODDAT,"$_/modinfo.dat");
  @mid = <MODDAT>;
  close(MODDAT);
  chomp $mid[0];
  chomp $mid[1];
  chomp $mid[2];
  print "<A HREF=\"$WWWSAPFAD/admin/$_/$mid[0]\" onmouseover=\"self.status=\'$mid[2]\';return true;\">$mid[1]</A><BR>\n";
}

print "</TD></TR></TABLE>";
print "<BR><BR><TT><B>Informationen: </B>Abteilung: $userinfo[8] Angelegt von:: $userinfo[10]</TT>";

print html_extfooter(getfullver());
