#!/usr/bin/perl
#################################################
# chpasswd.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# ndert das Passwort eines Benutzers auch in der shadow und updated
# dann die htpass Datei

require '../../config.pl';
require '../../formdata.pl';
require '../../userdata.pl';
require '../../pwdup.pl';
require '../../output.pl';

print $http_header;

$USERNAME = $ENV{'REMOTE_USER'};
if ($USERNAME eq "") {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Kein Benutzername gesendet. Dies ist ein Konfigurationsfehler.","","","",1);
  exit;  
}
if ($ENV{'REQUEST_METHOD'} ne "POST") {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Dieses Script aktzeptiert das gesendete Passwort nicht, da ist nicht &uuml;ber ein POST-Request gesendet wurde.","","","",1);
  exit;
}
$FORMDATEN = <STDIN>;  # (Daten werden gepostet METHOD=POST)
chomp($FORMDATEN);
%PWDFORMDATEN = hashFormData($FORMDATEN);
@USERDATEN = getuserdata($USERNAME);
if (@USERDATEN == 0) {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Es ist ein erweiterter Fehler Nr. 1 aufgetreten. <BR>Das hei&szlig;t: Es existiert ein Eintrag in der Server-Passwortdatei, aber keiner in der Globalen Passwortdatei.");
  exit;  
}
# altes Passwort berprfen ...
$CSALT = substr($USERDATEN[1],0,2);
if ($MAX_PASSWD_LEN == 0) {
  $CRSTR = crypt $PWDFORMDATEN{'oldpass'},$CSALT;
} else {
  $CRSTR = crypt substr($PWDFORMDATEN{'oldpass'},0,$MAX_PASSWD_LEN),$CSALT;
}
if ($CRSTR ne $USERDATEN[1]) {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Das eingegebene alte Passwort stimmt nicht mit dem aktuellen Passwort &uuml;berein.",1,"index.cgi","Noch einmal versuchen",1);
  exit;
}
# ist PWD1 = PWD2 ???
if ($PWDFORMDATEN{'newpass'} ne $PWDFORMDATEN{'newpass2'}) {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Die Passwortwiederholung stimmt nicht mit dem neuen Passwort &uuml;berein.",1,"index.cgi","Noch einmal versuchen",1);
  exit;
}
# ist die Laenge ok?
if (length($PWDFORMDATEN{'newpass'}) < 5) {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Das neue Passwort ist zu kurz (Minimum 5 Zeichen!).",1,"index.cgi","Noch einmal versuchen",1);
  exit;
}
if (length($PWDFORMDATEN{'newpass'}) > 8) {
  print html_webtoolserror("Eigenes Passwort &auml;ndern","Das neue Passwort ist zu lang (Maximum 8 Zeichen!).",1,"index.cgi","Noch einmal versuchen",1);
  exit;
}
# Sind die Zeichen im Passwort legal ?
$tmppasswd = $PWDFORMDATEN{'newpass'};
$tmppasswd =~ s/[^a-zA-Z0-9\-\.\,\*\+\_\$]//g;
if ($tmppasswd ne $PWDFORMDATEN{'newpass'}) {
  print html_webtoolserror("Im neuen Passwort sind illegale Zeichen vorhanden.","Die Passwortwiederholung stimmt ",1,"index.cgi","Noch einmal versuchen",1);
  exit;
}
# Passwort ndern ...
#system "\/bin\/echo \"$USERNAME:$PWDFORMDATEN{'newpass'}\" \| \/usr\/sbin\/chpasswd";
open (PASSCH,"|/usr/sbin/chpasswd");
print PASSCH "$USERNAME:$PWDFORMDATEN{'newpass'}\n";
close(PASSCH);
$erg=system("/usr/bin/smbpasswd -a -s $USERNAME $PWDFORMDATEN{'newpass'} >> /dev/null");
$erg=(getpwnam($USERNAME))[1];

createpassdata();
print html_webtoolsinfo("Eigenes Passwort &auml;ndern","Das Passwort wurde ge&auml;ndert. Wenn Sie jetzt auf Hauptmen&uuml; klicken, m&uuml;ssen Sie sich neu anmelden.",1,"","",1);
