# Konfigurationen fr das Tools Paket ...
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#

# Pfad zu den notwendigen Linux-Programmen
$ENV{'PATH'}="/bin:/usr/bin:/sbin:/usr/sbin";

# $WWWHOMEPFAD gibt den Pfad zum WWW-Homebverzeichnis an
# in der Regel /home/www (ohne den letzen Schrgstrich)
$WWWHOMEPFAD = '/srv/www/htdocs';

# $WWWSAPFAD gibt den WWW-Pfad (von WWW-Homeverzeichnis) zu den Tools
# Hauptpfad an. (ohne den letzten Schrgstrich)
$WWWSAPFAD = '/tools';

# $HTPASSFILE gibt den Pfad + Datei auf das ht-Passwort-File an.
$HTPASSFILE = '/etc/httpd/yfh.pwd';

# @SAGRUPPENNAMEN geben die Namen der Tools-Gruppen an.
# Die ersten drei Felder geben die Standartnamen an. Die Liste
# sollte auf jeden Fall immer drei Namen enthalten.
# Folgender Aufbau: [0]=Admin-Gruppe, [1] = Leiter-Gruppe, [2] = Mitarbeiter
@SAGRUPPENNAMEN=('ntadmin','leiter','mitarbeiter');

# %GRUPPENRECHT gibt die Gruppennamen und die Zugehrige Recht ID an.
# Es gilt 1=admin, 2=leiter, 3=mitarbeiterer.
#$GRUPPENRECHT{'admin'} = 1;
#$GRUPPENRECHT{'leiter'} = 2;
#$GRUPPENRECHT{'mitarbeiter'} = 3;
# Wenn Sie keine Automatische Zuordnung der Daten haben wollen, dann
# muessen Sie die Kommentare(#) der drei Zeilen nach oben entfernen und in
# den drei Zeilen nach unten hinzufuegen.
$GRUPPENRECHT{$SAGRUPPENNAMEN[0]} = 1;
$GRUPPENRECHT{$SAGRUPPENNAMEN[1]} = 2;
$GRUPPENRECHT{$SAGRUPPENNAMEN[2]} = 3;
# Wenn Sie zusaetzliche Gruppe haben, dann definieren Sie das Recht hier
# $GRUPPENRECHT{'HIER DEN GRUPPENNAME EINTRAGEN'} = 3;

# $MAX_PASSWD_LEN gibt die Anzahl der signifikanten Zeichen eines Passwortes
# an. Nheres siehe /etc/login.defs. In der Regel-Installation der SuSE ist 
# dieser Wert auf 8. 0 Bedeutet alle Zeichen sind signifikant.
$MAX_PASSWD_LEN = 8;

# $CD_TO_DIR gibt das Zielverzeichnis des CD-Mountens an. Normalerweise
# /media/cdrom
$CD_TO_DIR = "/media/cdrom";

# $CD_DEVICE gibt das Device des CD-Laufwerkes an. Normalerweise
# /dev/cdrom
$CD_DEVICE = "/dev/cdrom";

# Man kann logging einschalten. Wenn die Variable $WT_LOGGING = 1 ist, 
# dann wird in die Datei, die durch $WT_LOGFILE angegeben wird geloggt.
$WT_LOGGING = 0; # aus
$WT_LOGFILE = "/var/log/tools.log";

# $LH_GROUPADMIN gibt an, welche Rechte ein Leiter bei Sekundaeren Gruppen
# hat. Folgende Werte werden aktzeptiert 
# 1:Leiter darf Sekundaere Gruppen nur loeschen, 
# 2:Leiter darf einem Mitarbeiter die sekundaeren Gruppen geben, in
# denen er selber Mitglied ist, 
# andere Werte:Leiter darf alle sekundaeren Gruppen einem Mitarbeiter geben.
$LH_GROUPADMIN = 2;

# $SHOW_HELP muss auf 1 gesetzt werden, damit das Fragezeichen-Link an der 
# oberen rechten Seite erscheint.
$SHOW_HELP = 0;

# $FIRST_CH_UID gibt die UserID an, ab der Benutzer zum ndern angezeigt 
# werden. Wenn man das Verndern/Lschen des root-Account verhindern mchte,
# sollte man diesen Wert entsprechend hoch setzen.
$FIRST_CH_UID = 500;

# $LAST_CH_UID gibt die letzte UID an, nach der Benutzer zum ndern nicht mehr 
# angezeigt werden. (nobody hat 65534 oder so hnlich)
$LAST_CH_UID = 10000;

# $FIRST_NEW_UID gibt die erste UID an, die fr neue Benutzer vergeben wird.
$FIRST_NEW_UID = 500;

# $FIRST_CH_GID gibt die GruppenID an, ab der Gruppen verwendet werden 
# duerfen. Zum Aendern der Gruppendaten, oder zum Aendern von Benutzerdaten.
$FIRST_CH_GID = 70;

# $LAST_CH_GID gibt die Letzte GruppenID an, bis zu der Gruppendaten ver-
# aendert werden duerfen, oder Gruppendaten fuer Benutzer verwendet werden
# duerfen.
$LAST_CH_GID = 10000;

# $NEWUSER_SHELL gibt an, welche Shell ein Neuer Benutzer Standartmaessig
# bekommt.
$NEWUSER_SHELL = "/usr/bin/passwd";

# $USERADMINPFAD gibt den Pfad zum Benutzerverwaltungsmodul an.
$USERADMINPFAD = "benutzer/";

# $QUOTAUSER gibt den Benutzer an, dessen Quotas kopiert werden
#$QUOTAUSER="beispiel";

# $INTERFACE gibt an, ber welches Gert die Internetverbindung luft
$INTERFACE="ippp0";
