#################################################
# output.pl
# Diese Perl-Lib enthaelt einige Standart WebTools HTML-Texte.
#
# (C) Arbeitskreis Linux, 
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Standart http-Header
$http_header = "Content-type: text/html\n\n";

# Standardheader (Parameter1 = Netscape Titelzeile)
sub html_header {
  return "<HTML><HEAD><TITLE>$_[0]</TITLE></HEAD>\n";
}

# Diese Perl-Lib enthaelt Routinen zum ermitteln von Versionsinformationen


# Ermittelt den Versionsstring in einer Datei (Parameter1: Dateiname)
sub getverstring {
  my $dateiname = $_[0];
  local(@scriptzeilen);
  
  open SCRIPTDATEI,"<$dateiname";
  @scriptzeilen = <SCRIPTDATEI>;
  close SCRIPTDATEI;
  foreach (@scriptzeilen) {
    chomp;
    if (substr(uc($_),0,7) eq "# WT_VK") {
      return $_;
    }
  }
  return "";
}

# Gibt einen bestimmten Teil aus einem Versionsstring zurueck.
# Parameter1=Versionsstring
# Parameter2=Teildefinition: 1=akt Hauptversion 2=akt Unterversion 3=akt Datum
#                            4=alt Hauptversion 5=alt Unterversion 4=alt Datum
sub getverpart {
  my $vstr = $_[0];
  my $partid = $_[1];
  local ($zaehler, $resultat, $cpart, $zeichen);
  
  $resultat="";
  $cpart=0;
  for ($zaehler=0; $zaehler<length($vstr); $zaehler++) {
    $zeichen = substr($vstr,$zaehler,1);
    if ($zeichen eq ".") {
      $cpart++;
    }
    if (($partid==3)&&($cpart==3)&&($zeichen eq "-")) {
      $cpart++;
    }
    if (($zeichen ne ".")&&($cpart==$partid)) {
      $resultat = "$resultat$zeichen";
    }
  }
  return $resultat;
}

# Ermittelt die Hauptversion des aktuellen Scripts zurueck.
sub getcfhver {
  local($resultat, $verstr);
  
  $resultat="";
  $verstr = getverstring($0);
  if ($verstr ne "") {
    $resultat = getverpart($verstr,1);
  }
  return $resultat;
}

#  Ermittelt die Nebenversion des aktuellen Scripts zurueck.
sub getcfnver {
  local($resultat, $verstr);
  
  $resultat="";
  $verstr = getverstring($0);
  if ($verstr ne "") {
    $resultat = sprintf("%02d",getverpart($verstr,2));
  }
  return $resultat;
}

# Gibt Haupt und Nebenversion zurueck.
sub getcfver {
  local($resultat);
  
  $resultat = sprintf "%s.%s",getcfhver(),getcfnver();
  return $resultat;
}


#Gibt einen vollen Versionsstring zurueck. Mit Webtoolsver/Scriptver
sub getfullver {
  local($resultat);
  
  $resultat = getcfver();
  $resultat = "$webtools_version/$resultat";
  return $resultat;
}

# Die folgende Funktion gibt die URL der Hilfedatei zurueck.
sub get_hilfeurl {
  return "";
}

# Kopf des Bodys (Parameter1 = Netscape Farbe, Parameter2 = Untertitel,
# Parameter3 = Versionsstring, Parameter4=HilfeURL(optional))
sub html_webtoolsheader {
  local($res);
  
  $res = "";
  $res = "<BODY BGCOLOR=$_[0] VLINK=#0000ff><TABLE WIDTH=100%><TR><TD><IMG SRC=\"$WWWSAPFAD/images/tlogo.gif\" ALT=\"WebTools\" ALIGN=\"bottom\">$_[2]</TD><TD ALIGN=right>\n<H1>$res";

  return "$res$_[1]</H1></TD></TR></TABLE>\n<HR SIZE=1>\n";
}

# Fehlermeldung (Parameter1 = Untertitel, Parameter2 = Fehlermeldung, Parameter3 = wenn 1, dann Hauptmenue Link, Parameter4 = URL zum weiteren Link, Parameter5 bezeichnung des weiteren Links
sub html_webtoolserror {
  local ($res,$footer,$verinfo,$verdata);
  
  $verdata = "";
  $verinfo = "";
  if ($_[5] ne "") {
    $verdata = $webtools_version;
    $verinfo = getfullver();
  }
  $res = html_webtoolsheader("#ff4040",$_[0],$verdata);
  $res = "$res<H1>Fehler:</H1>\n<TT>$_[1]</TT>\n";
  if ($_[2] == 1) {
    $res = "$res<BR><A HREF=\"$WWWSAPFAD/admin/index.cgi\">Hauptmen&uuml;</A>\n";
  }
  if (($_[3] ne "")&&($_[4] ne "")) {
    $res = "$res<BR><A HREF=\"$_[3]\">$_[4]</A>\n";
  }
  $footer = html_extfooter($verinfo);
  $res = "$res$footer\n";
  return $res;
}

# Infomeldung (Parameter1 = Untertitel, Parameter2 = Infomeldung, Parameter3 = wenn 1, dann Hauptmenue Link, Parameter4 = URL zum weiteren Link, Parameter5 bezeichnung des weiteren Links, Parameter6: wenn 1, dann werden Versionsinfos gezeigt.
sub html_webtoolsinfo {
  local ($res,$verdata,$verinfo,$footer);
  
  $verdata = "";
  $verinfo = "";
  if ($_[5] ne "") {
    $verdata = $webtools_version;
    $verinfo = getfullver();
  }
  $res = html_webtoolsheader("#ffff00",$_[0],$verdata);
  $res = "$res<H1>Info:</H1>\n<TT>$_[1]</TT>\n";
  if ($_[2] == 1) {
    $res = "$res<BR><A HREF=\"$WWWSAPFAD/admin/index.cgi\">Hauptmen&uuml;</A>\n";
  }
  if (($_[3] ne "")&&($_[4] ne "")) {
    $res = "$res<BR><A HREF=\"$_[3]\">$_[4]</A>\n";
  }
  $footer = html_extfooter($verinfo);
  $res = "$res$footer\n";
  return $res;
}

# Gibt einen erweiterten Footer zurueck.
# Parameter1 = Text nach copyright Text.
sub html_extfooter {
  my $infostr = $_[0];
  
  return "<!-- (C) by AK Linux --><HR SIZE=1>\n<CENTER><FONT SIZE=-2>&copy; 2002 by AK Linux $infostr</FONT></CENTER></BODY></HTML>";
}

# Erzeugt eine Tabelle mit einem Link. Dies sieht einer Schaltflaeche aehnlich
# Parameter1: Text der Schaltfl. / Parameter2: Link der Schaltfl.
sub html_webtoolslink {
  return "<TABLE BORDER=2 CELLSPACING=0 BORDERCOLOR=#c0c0c0 BGCOLOR=#c0c0c0 CELLPADDING=1><TR><TD><A HREF=\"$_[1]\"><FONT COLOR=#000000>$_[0]</FONT></A></TD></TR></TABLE>";
}

# Erzeugt eine Buttonleiste als HTML-Code
# Als Parameter wird eine Liste mit folgendem Format bergeben:
# 2 Felder gehren zu einer Schaltflche.
# wenn 1. Feld __reset ist, dann wird eine Reset-Schaltflche eingebaut.
# wenn 1. Feld __submit ist, dann wird eine Submit-Schaltflche eingebaut.
# jeder andere Wert beschreibt eine URL.
# das zweite Feld beschreibt jeweils die Beschriftung der Schaltflche.
sub html_webtoolsbuttons {
  local(@parameterliste, $buttontyp, $feldtyp, $buttonlink, $res, $tmpstr);
  
  $res = "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 WIDTH=100%><TR>";
  @parameterliste = @_;
  $feldtyp=0;
  foreach (@parameterliste) {
    if ($feldtyp == 0) {
      if ($_ eq "__reset") {
        $feldtyp = 1;
        $buttontyp=1;
      } elsif ($_ eq "__submit") {
        $feldtyp = 1;
        $buttontyp=2;
      } else {
        $feldtyp = 1;
        $buttontyp=0;
        $buttonlink=$_;
      }
      $res = "$res<TD BGCOLOR=#c0c0c0 ALIGN=center>";
    } else {
      $feldtyp=0;
      if ($buttontyp == 0) {
        $tmpstr = html_webtoolslink($_,$buttonlink);
        $res = "$res$tmpstr";
      }
      if ($buttontyp == 1) {
        $res = "$res<INPUT TYPE=reset VALUE=\"$_\">";
      }
      if ($buttontyp == 2) {
        $res = "$res<INPUT TYPE=submit VALUE=\"$_\">";
      }
      $res = "$res</TD><TD BGCOLOR=#c0c0c0><BR></TD>";
    }
  } 
  $res = "$res</TD></TR></TABLE>";
  return $res;
}

1;