#################################################
# usrdata.pl
# Diese Datei bearbeitet Benutzerdaten
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.200300811-AV.4.00.00000000

#############################################################################
# Routinen die in dieser Datei enthalten sind ...
#
# getuserdata  	Ermittelt die Benutzerdaten zu einem Loginname
# 		Parameter1 : Loginname
#		Rckgabe   : Array mit Loginname, Passwort(E), Name, UID, 
#			     GID, Home, Shell, Recht, Abteilung, AbteilungID, 
#			     Leiter, LeiterID
#
# Recht : Wert 0=Other, 1, Admin, 2=Leiter, 3=Mitarbeiter
# Genaueres siehe config.pl
# ------------------------------------------------------------------------
# getuserdata2 	Ermittelt die Benutzerdaten zu einem Loginname
# 		Parameter1 : Loginname
#		Rckgabe   : Array mit Loginname, Name, Abteilung
#               Eingefhrt zur Beschl. der Benutzerverwaltung
# Recht : Wert 0=Other, 1, Admin, 2=Leiter, 3=Mitarbeiter
# Genaueres siehe config.pl
# ------------------------------------------------------------------------
# getgroups	Gibt eine Liste mit allen Gruppen zurueck, in denen der
#		Benutzer Mitglied ist.
# 		Parameter1 : Loginname
#		Rueckgabe  : Liste mit den Gruppen zurueck.
# ------------------------------------------------------------------------
# checkgroup	Testet ob ein Benutzer in einer Gruppe Mitglied ist.
#		Parameter1 : Loginname
#		Parameter2 : Gruppenname
#		Rueckgabe  : 1:Benutzer ist Mitglied, 0:Benutzer ist nicht
#			     Mitglied.
# ------------------------------------------------------------------------
# getuserlist	Gibt eine Liste mit allen Benutzer zurueck, deren UID im
#		Bereich der Definition in der config.pl ist.
#		Rueckgabe  : Liste mit den Loginnamen
# ------------------------------------------------------------------------
# html_userlist	Gibt einen String in HTML-Form fuer Listen zurueck, in
#		denen alle Benutzer angegeben sind. (config.pl)
#		Rueckgabe  : String in folgender Form:
#		<OPTION>[Name]<OPTION>[Name](...)
# ------------------------------------------------------------------------
# html_groups	Gibt alle Gruppen in HTML-Form fuer Listen zurueck. Alle
#		Gruppen, in denen der Benutzer Mitglied(sekundaer) ist, 
#		werden mit SELECTED zurueckgegeben.
#		Parameter1 : Loginname
#		Rueckgabe  : String im HTML-Listen-Format(s. o.)
# ------------------------------------------------------------------------
# html_shells	Gibt eine Liste aller Shells aus /etc/shells zurueck.
#		Es wird ein String in HTML-Listen-Form zurueckgegeben, die
#		Shell, die den Parameter angibt wird mit SELECTED markiert
#		Parameter1 : Shell+Pfad
#		Rueckgabe  : String in HTML-Listen-Format(s. o.)
# ------------------------------------------------------------------------
# html_saright	Gibt einen String in HTML-Listen-Form zurueck der die 
# 		SA-Gruppen enthaelt.
#		Parameter1 : 0-3 (Gruppe die SELECTED sein soll)
#		Parameter2 : 0-3 (Recht der Person, die aendern will.
#		Rueckgabe  : String in HTML-Listen-Form(s. o.)
# ------------------------------------------------------------------------
# html_allgroups Gibt eine Liste aller Gruppen in HTML-Listen-Form aus.
#		Parameter1 : GID, der Gruppe die SELECTED sein soll.
# 		Rueckgabe  : String in HTML-Listen-Form(s. o.)
# ------------------------------------------------------------------------
# convert_special_chars Wandelt Sonderzeichen in Standart zeichen.
#		Parameter1 : String mit Sonderzeichen (z.B. AUmlaut)
#		Rueckgabe  : String ohne Sonderzeichen (zu ae)
# ------------------------------------------------------------------------
# createnewuser Erstellt einen Account. Achtung, die Funktion hat Ausgaben
# 		Parameter  : Liste mit 8 Feldern
# 		_[0] = VollerName _[1] = username, _[2] = passwort, 
#		_[3] = homedir, _[4] = SA-Recht, _[5] = Abteilung, 
#		_[6] = Shell, _[7] = ExtraStr 
# _[1] = "", dann ist username = xx0000 xx=initialen 0000 = Zahl ab 1000
# _[2] = "", dann ist passwort = Vorname in klein
# _[3] = "", dann ist homedir = "/home/[username]"
# _[6] = "", dann ist shell = "Keine Shell"
# _[7] ist fuer Abteilung, anlegender Leiter da.
#		Rueckgabe  : Keine
# ------------------------------------------------------------------------
# getclassid 	Ermittelt eine ID fuer eine Abteilung. Erstellt eine neue ID
#		Parameter1 : Name der Abteilung (z.B. Buchhaltung)
#		Rueckgabe  : Zahl zwischen 1000 und groesser
# ------------------------------------------------------------------------
# getlname	Gibt den vollen Name eines Benutzers zurueck.
#		Parameter1 : Loginname
#		Rueckgabe  : voller Name
# ------------------------------------------------------------------------
# getuseringroup Gibt eine Liste mit allen Benutzern die in einer Gruppe
#		Mitglied sind zurueck.
# ------------------------------------------------------------------------
# createnewgroup Erstellt eine neue Gruppe. Achtung diese Funktion hat
#		Ausgaben.
# 		Parameter1 : grpname
# ------------------------------------------------------------------------
# getlehrer	Ermittelt den Leeiterloginnamen zu einem Loginname
#		Parameter1 : Loginname1
#		Rueckgabe  : Loginname2 des Leiters der fuer Loginname1
#			     zustaendig ist.
# ------------------------------------------------------------------------
# getauth	Gibt true zurueck, wenn modinfo.dat zugang erlaubt.
#		Parameter1 : Tools-Gruppe (0-3)
#		Rueckgabe  : true oder false
# ------------------------------------------------------------------------
# extgrpcheck   Gibt wahr zurueck, wenn die primaere Gruppe auch eine
#               sekundaere Gruppe ist.
# ------------------------------------------------------------------------
# 

while (@groups=getgrent) {
 $grname{$groups[2]}=$groups[0];
 $grmitglieder{$groups[0]}=$groups[3];
}
undef @groups;

#Gibt eine Liste aller Gruppen zurueck.
sub getgroups {
  my $username = $_[0];
  local( @groups);
  my @userinfo;
  my $gruppe;
  @userinfo=getpwnam $username;
  @groups=($grname{$userinfo[3]});
  foreach $gruppe (keys %grmitglieder) {
    if ($grmitglieder{$gruppe} =~ /.*\b$username\b.*/ ) {
      if ($gruppe ne $groups[0]) {
    	push @groups, $gruppe;
      }
    }
  }
  return @groups;
}

# Parameter 1: loginname
sub extgrpcheck {
  my $username = $_[0];
  local($groupres,@groupfile,$fres,@dummy,$userliste);
  
  $groupres = (getgroups($username))[0];
  setgrent;
  while (@groupfile = getgrent) {
    if ($groupfile[0] eq $groupres) {
      $userliste = $groupfile[3];
      @dummy = split(/\,/,$userliste);
      if ($username eq (grep(/^$username$/,@dummy))[0]) {
        return 1;
      }
    }
  }
  return '';
}

# Gibt 1 zurueck, wenn ein Benutzer in der Gruppe vorhanden ist.
# Parameter: username, gruppe
sub checkgroup {
  my $username = $_[0];
  my $gruppenname = $_[1];
  local($res, @gruppen);
  
  @gruppen = getgroups($username);
  $res = '';
  foreach (@gruppen) {
    if ($gruppenname eq $_) { $res = 1; }
  }
  return $res;
}

sub getuserdata {
  my $username = $_[0];
  local(@userinfodata);
  local($shadowstring, $userinfostring, $passwdstring);
  local(@shadowteile, @userinfoteile, @passwdteile); 
  local(@resultat, @GRPARRAY, $GRPSTRING, @tmp);
  local(@extuserdata);
  
  setpwent;
  while(@passwdteile=getpwent) {
    if ($passwdteile[0] eq $username) {
      $passwdstring = $passwdteile[0];
      last;
    }
  }
  # unzulssige Benutzer ausblenden
  if (($passwdteile[2] < $FIRST_CH_UID) || ($passwdteile[2] > $LAST_CH_UID)) {
    return ;
  }
  @tmp = split(/,/,$passwdteile[6],-1);
  $passwdteile[6] = $tmp[0];
  if (@tmp > 4) {
    @extuserdata = split(/;/,$tmp[4],-1);
  } else {
    @extuserdata = ("","","","");
  }
  # Abteilung
  # AbteilungsID
  # Leiter
  # LeiterID (username)
  if ($passwdstring eq "") {
    return ;
  }
  $GRPARRAY[0] = 100;
  foreach (@SAGRUPPENNAMEN) {
    if (checkgroup($username, $_)) {
      if ($GRUPPENRECHT{$_}<$GRPARRAY[0]) {
        $GRPARRAY[0] = $GRUPPENRECHT{$_};
      }
    }
  }
  @resultat = ($passwdteile[0],$passwdteile[1],$passwdteile[6],
  $passwdteile[2],$passwdteile[3],$passwdteile[7],$passwdteile[8],$GRPARRAY[0],
  $extuserdata[0],$extuserdata[1],$extuserdata[2],$extuserdata[3]);
  return @resultat;
}

sub getuserdata2 {
  my $username = $_[0];
  local(@extuserdata, @resultat, @passwddata, @tmp);
  setpwent;  
  while(@passwddata=getpwent) {
    if ($passwddata[0] eq $username) {
      $passwdstring = $passwddata[0];
      last;
    }
  }
  @tmp = split(/,/,$passwddata[6],-1);
  $passwddata[6] = $tmp[0];
  if (!$passwddata[6]) {
    $passwddata[6] = "&nbsp;";
  }
  if (@tmp > 4) {
    @extuserdata = split(/;/,$tmp[4],-1);
  } else {
    @extuserdata = ("&nbsp;","","","");
  }
  if ($passwdstring eq "") {
    return ;
  }
  $dummy=4711;
  @resultat = ($passwddata[0],$passwddata[6],$extuserdata[0]);
  return @resultat;
}

# Gibt eine Liste mit allen Benutzernamen zurck.
# Wenn die UserID kleiner $FIRST_CH_UID ist wird der Eintrag nicht zurck
# gegeben.
sub getuserlist {
  local (@pwdlist, @unamelist);

  setpwent;
  while (@pwdlist=getpwent) {
    if (($pwdlist[2]>=$FIRST_CH_UID) && ($pwdlist[2]<=$LAST_CH_UID)) {
      push @unamelist, $pwdlist[0];
    }
  }
  return @unamelist;
}

# Gibt alle Benutzer in html-Listenform zurueck
sub html_userlist {
  my $grpname = $_[0];
  local($res, @userliste);
  
  $res = "";
  @userliste = getuserlist();
  foreach(@userliste) {
    $res = "$res<OPTION>$_";
  }
  return $res;
}

# Gibt die Gruppen eines Benutzers in HTML-Listenform aus.(+ alle anderen)
sub html_groups {
  my $username = $_[0];
  my $adminname = $_[1];
  local($zeile, @gruppenliste, @alleGruppen, $res, @outGruppen, $equal, $tmp, @admindata);
  
  @admindata = getuserdata($adminname);
  @gruppenliste = getgroups($username);

  @alleGruppen=();
  setgrent;
  while (@zeile=getgrent) {
   if (($zeile[2] >= $FIRST_CH_GID) && ($zeile[2] <= $LAST_CH_GID)) {
     if ($GRUPPENRECHT{$zeile[0]}==0) {
       push @alleGruppen, $zeile[0];
     }
   }
  }
  if (!extgrpcheck($username)) {
    shift @gruppenliste;
  }
  $equal = 0;
  foreach(@gruppenliste) {
    $equal = 0;
    foreach $tmp (@alleGruppen) {
      if ($tmp eq $_) {$equal=-1;}
    }
    if ($equal == 0) {push @outGruppen, $_};
  }
  @outGruppen = (@outGruppen, @alleGruppen);
  @outGruppen = sort @outGruppen;
  $res = "";
  foreach(@outGruppen) {
    if ($GRUPPENRECHT{$_}==0) {
      $equal = 0;
      foreach $tmp (@gruppenliste) {
        if ($_ eq $tmp) {$equal = -1; }
      }
      if ($equal == -1) {
        $res = sprintf "%s<OPTION SELECTED>%s",$res,$_;
      } else {
        if (($admindata[7]==1)||
            (($LH_GROUPADMIN==2)&&(checkgroup($adminname,$_)))||
            (($LH_GROUPADMIN!=1)&&($LH_GROUPADMIN!=2))) {
          $res = sprintf "%s<OPTION>%s",$res,$_;
        }
      }
    }
  }
  return $res;
}

# Gibt die Shells in /etc/shells in HTML-Drop-Down Style aus. Der Parameter
# gibt die aktuelle Shell an.
sub html_shells {
  my $shellname = $_[0];
  local (@shelllist, $html_str);
  
  open SHELLS, '</etc/shells';
  @shelllist = <SHELLS>;
  close SHELLS;
  if ($shellname eq "") {
    $html_str = "<OPTION VALUE=\"\" SELECTED>Keine Shell";
  } else {
    $html_str = "<OPTION VALUE=\"\">Keine Shell";
  }
  foreach (@shelllist) {
    chomp;
    if (($_ ne "")&&(substr($_,0,1) ne "#")) {
      if ($shellname eq $_) {
        $html_str = sprintf "%s<OPTION SELECTED>%s", $html_str, $_; 
      } else {
        $html_str = sprintf "%s<OPTION>%s", $html_str, $_;
      }
    }
  }
  return $html_str;
}

# Diese Routine gibt eine html-liste der SA-Rechte aus. der Parameter gibt
# Das aktuelle Recht an. (Zahl von 0-3) 
sub html_saright {
  my $username = $_[0];
  my $userright = $_[1];
  local ($html_str, @ingruppen, $aa);
  
  if ($username eq "") {
    @ingruppen = ($SAGRUPPENNAMEN[2]);
  } else {
    @ingruppen = getgroups($username);
  }
  $html_str = "";
  foreach(@SAGRUPPENNAMEN) {
    $aa = $_;
    if ($aa eq (grep(/^$aa$/,@ingruppen))[0]) {
      $html_str = sprintf "%s<OPTION SELECTED>$aa", $html_str;
    } else {
      if (($GRUPPENRECHT{$aa}>=3)||($userright==1)) {
        $html_str = sprintf "%s<OPTION>$aa", $html_str;
      }
    }
  }
  return $html_str;
}

# Gibt einen HTML-String zurueck. Der Parameter ist eine GID, der
# die ausgewaehlte Gruppe angibt.
sub html_allgroups {
  my $grpname = $_[0];
  my $adminname = $_[1];
  local($zeile, $htmlstr, @admindata);
  
  @admindata = getuserdata($adminname);
  $htmlstr = "";
  setgrent;
  while (@zeile=getgrent) {
   if (($zeile[2] >= $FIRST_CH_GID) && ($zeile[2] <= $LAST_CH_GID)) {
     if ($GRUPPENRECHT{$zeile[0]}==0) {
       if ($zeile[2] eq $grpname) {
        $htmlstr = sprintf "%s<OPTION SELECTED>%s",$htmlstr,$zeile[0];
       } else {
         if (($admindata[7]==1)||
          (($LH_GROUPADMIN==2)&&(checkgroup($adminname,$zeile[0])))||
          (($LH_GROUPADMIN!=1)&&($LH_GROUPADMIN!=2))) {
            $htmlstr = sprintf "%s<OPTION>%s",$htmlstr,$zeile[0];
         }
       }
     }
   }
  }
#  $htmlstr = "<OPTION>$adminname $htmlstr";
  return $htmlstr;
}

# Wandelt Sonderzeichen in Standardzeichen.
sub convert_special_chars {
  my $resstr2 = $_[0];
  local ($resstr);
  
  $resstr = $resstr2;
  $resstr =~ s//ae/g;
  $resstr =~ s//Ae/g;
  $resstr =~ s//oe/g;
  $resstr =~ s//Oe/g;
  $resstr =~ s//ue/g;
  $resstr =~ s//Us/g;
  $resstr =~ s//ss/g;
  return $resstr;
}

# Erstellt einen Account.
# Parameter: Liste mit 8 Feldern
# _[0] = VollerName _[1] = username, _[2] = passwort, _[3] = homedir
# _[4] = SA-Recht, _[5] = Klasse, _[6] = Shell _[7] = ExtraStr
# _[1] = "", dann ist username = xx0000 xx=initialen 0000 = Zahl ab 1000
# _[2] = "", dann ist passwort = Vorname in klein
# _[3] = "", dann ist homedir = "/home/[username]"
# _[6] = "", dann ist shell = "Keine Shell"
# _[7] ist fuer Klasse, anlegender Lehrer da.
sub createnewuser {
  my $UD_fullname = $_[0];
  my $UD_username = $_[1];
  my $UD_password = $_[2];
  my $UD_homedir = $_[3];
  my $UD_saright = $_[4];
  my $UD_class = $_[5];
  my $UD_shell = $_[6];
  my $UD_other = $_[7];
  local ($SYSres, @RESvals, $sagroup, %UIDS, %LOGNAMES, $UID);
  local ($VORNAME, $NAME, $ini, $ini1, $ini2, $LOGNAME, $ID, $SARDATA);

  ## HASH-Tables aus /etc/passwd erzeugen
  setpwent;
  while (@passwd=getpwent) {
        $UIDS{$passwd[2]} = $passwd [0];
        $LOGNAMES{$passwd[0]} = $passwd [2];
  }
  endpwent;

  # Unsichere Zeichen entfernen ...
  $UD_fullname = convert_special_chars($UD_fullname);
  $UD_fullname =~ s/[^a-zA-Z0-9\-\ \_]//g;
  $UD_username =~ s/[^a-zA-Z0-9\-\_]//g;
  $UD_password =~ s/[^a-zA-Z0-9\-\ \_]//g;
  $UD_shell =~ s/[^a-zA-Z0-9\-\_\/]//g;
  $UD_homedir =~ s/[^a-zA-Z0-9\-\_\/]//g;
  $UID = $FIRST_NEW_UID;
  #naechste UID finden
  while (exists $UIDS{$UID}) {
        $UID++;
  }
  if ($UD_fullname eq "") {
    print "Benutzer ohne vollen Namen nicht hinzugefgt.<br>\n";
  } else {
    $VORNAME = (split /\ /, $UD_fullname)[0];
    $VORNAME =~ s/[^a-zA-Z0-9\-\_]//g;
    $NAME = substr $UD_fullname, length($VORNAME)+1;
    $NAME =~ s/[^a-zA-Z0-9\-\_]//g;
    if ($UD_password eq "") {$UD_password = lc($VORNAME); }
    if ($UD_username eq "") {
      $ini1=lc(substr($VORNAME, 0, 1));
      $ini2=lc(substr($NAME, 0, 1));
      $ini="$ini1$ini2";
      $ini =~ tr//ooaauus/;
  
      $ID=1001;
      $LOGNAME="$ini$ID"; 
      while (exists $LOGNAMES{$LOGNAME})
      {
         $ID++; 
         $LOGNAME="$ini$ID"; 
      }
      $UD_username = $LOGNAME;
    }
    if ($UD_homedir eq "") {
      $UD_homedir = "/home/$UD_username";
    }
    $SARDATA = "$UD_saright";
    @args=("/usr/sbin/useradd","-u","$UID","-s","$UD_shell","-d", "$UD_homedir");
    @args=(@args,"-c","$VORNAME $NAME","-m");
    if ($SARDATA ne "") {@args=(@args,"-g","$SARDATA");}
    @args=(@args,"$UD_username");
    $SYSres = system(@args);
    if ($SYSres==0) {
      print "Benutzer <TT>$UD_username</TT> ($UD_fullname, Passwort:<TT>$UD_password</TT>) hinzugef&uuml;gt<BR>\n";
      @args=("/usr/bin/chfn","-o",$UD_other,$UD_username);
      system(@args);
      system("/usr/bin/chage","-m","0",$UD_username);
      open (PASSCH,"| /usr/sbin/chpasswd");
      print PASSCH "$UD_username:$UD_password\n";
      close(PASSCH);
      $erg=system("/usr/bin/smbpasswd -s -a $UD_username $UD_password  >> /dev/null");
      @args=("/usr/sbin/edquota", "-p", "$QUOTAUSER", "$UD_username");
      system(@args);
    } else {
      print "Benutzer <TT>$UD_username</TT> ($UD_fullname) konnte nicht hinzugef&uuml;gt werden.<BR>\n";
    }
  }
}

# Ermittelt eine ID fuer eine Abteilung
sub getclassid {
  my $klasse = $_[0];
  local (@passwdentr, @spstrentr, $result, %usedCIDs);

  setpwent;  
  $resultat = "";
  while(@passwdentr=getpwent) {
    @spstrentr = split(/\,/,$passwdentr[6],-1);
    undef(@passwdentr);
    @passwdentr = split(/\;/,$spstrentr[6],-1);
    $usedCIDs{$passwdentr[1]}=1;
    if ($passwdentr[0] eq $klasse) {
      $result = $passwdentr[1];
    }
    undef(@passwdentr);
    undef(@spstrentr);
  }
  if ($result eq "") {
    $result = 1000;
    while ($usedCIDs{$result}==1) {
      $result++;
    }
  }
  return $result;
}

# Ermittelt den Name eines Benutzers
sub getlname {
  my $username = $_[0];
  local (@userdata);
  
  @userdata = getuserdata($username);
  return $userdata[2];
}

# Ermittelt die Benutzer, die in einer Gruppe sind.
sub getuseringroup {
  my $grpname = $_[0];
  local (@grpdata, $res, @userliste);
  
  $res="";
  setgrent;
  while(@grpdata=getgrent) {
    if ($grpdata[0] eq $grpname) {
      @userliste = split(/\s+/,$grpdata[3]);
      foreach(@userliste) {
        $res = "$res<A HREF=\"../$USERADMINPFAD\shuserdata.cgi?username=$_\">$_</A> &nbsp; ";
      }
    }
  }
  setpwent;
  while(@userliste=getpwent) {
   if ($userliste[3] eq (getgrnam($grpname))[2]) {
      $res = "$res<A HREF=\"../$USERADMINPFAD\shuserdata.cgi?username=$userliste[0]\">$userliste[0]</A> &nbsp; ";
   }
  }
  return $res;
}

# Erstellt eine neue Gruppe
# Paramter [0]=grpname
sub createnewgroup {
  my $grpname = $_[0];
  local(@args,$SYSres);
  
  @args=("/usr/sbin/groupadd",$grpname);
  $SYSres = system(@args);
  if ($SYSres) {
    print "Die Gruppe <TT>$grpname</TT> konnte nicht angelegt werden<BR>";
  } else {
    print "Die Gruppe <TT>$grpname</TT> wurde angelegt<BR>";
  }
}

sub getlehrer {
  my $username = $_[0];
  local(@userdata);
 
  @userdata = getuserdata($username);
  return $userdata[11];
}

sub getauth {
  my $saright = $_[0];
  local(@moddata);
  
  open (MODINFO, "<./modinfo.dat");
  @moddata = <MODINFO>;
  close(MODINFO);
  if (($saright == 1)&&($moddata[3]==1)) {return 1;}
  if (($saright == 2)&&($moddata[4]==1)) {return 1;}
  if (($saright == 3)&&($moddata[5]==1)) {return 1;}
  return '';
}

1; # Diese Zeile ist ntig !!!
